package com.kdanmobile.dragwebobject;

import android.content.Context;
import android.util.AttributeSet;
import android.util.Log;
import android.view.MotionEvent;
import android.widget.RelativeLayout;

/**
 * Created by Shan on 2017/10/16.
 */

public class TouchReceiveLayout extends RelativeLayout {

    public interface TouchReceiveInterface {

        void onReceiveTouchMoveEvent(MotionEvent event);

        void onReceiveTouchUpEvent(MotionEvent event);

    }

    private TouchReceiveInterface touchReceiveInterface;

    public TouchReceiveLayout(Context context) {
        super(context);
    }

    public TouchReceiveLayout(Context context, AttributeSet attrs) {
        super(context, attrs);
    }

    public void setTouchReceiveInterface(TouchReceiveInterface touchReceiveInterface) {
        this.touchReceiveInterface = touchReceiveInterface;
    }

    @Override
    public boolean dispatchTouchEvent(MotionEvent event) {
        switch (event.getActionMasked()) {

            case MotionEvent.ACTION_MOVE:
                Log.d("Debug", "out : ACTION_MOVE");
                if (touchReceiveInterface != null)
                    touchReceiveInterface.onReceiveTouchMoveEvent(event);
             break;

            case MotionEvent.ACTION_UP:
                Log.d("Debug", "out : ACTION_UP");
                if (touchReceiveInterface != null)
                    touchReceiveInterface.onReceiveTouchUpEvent(event);
                break;
        }
        return super.dispatchTouchEvent(event);
    }

}
