package com.kdanmobile.dragwebobject;

import android.content.Context;
import android.os.Build;
import android.os.Bundle;
import android.support.annotation.RequiresApi;
import android.support.v4.app.Fragment;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.webkit.JavascriptInterface;
import android.webkit.WebChromeClient;
import android.webkit.WebView;
import android.webkit.WebViewClient;


import butterknife.Bind;
import butterknife.ButterKnife;


/**
 * A simple {@link Fragment} subclass.
 * Activities that contain this fragment must implement the
 * {@link WebViewFragment.OnFragmentInteractionListener} interface
 * to handle interaction events.
 * Use the {@link WebViewFragment#newInstance} factory method to
 * create an instance of this fragment.
 */
public class WebViewFragment extends Fragment {

    private OnFragmentInteractionListener mListener;

    @Bind(R.id.web)
    protected WebView webView;

    public WebViewFragment() {
        // Required empty public constructor
    }

    public static WebViewFragment newInstance() {
        WebViewFragment fragment = new WebViewFragment();
        return fragment;
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.fragment_web_view, container, false);
        ButterKnife.bind(this, view);

        webView.setWebViewClient(new WebViewClient() {

//            @RequiresApi(api = Build.VERSION_CODES.LOLLIPOP)
//            @Override
//            public WebResourceResponse shouldInterceptRequest(WebView view, WebResourceRequest request) {
//
//                String interceptRequestString =
//                        request.getMethod() + "\n" +
//                                request.getRequestHeaders() + "\n" +
//                                request.getUrl();
//
//
////                String interfaceCallBackCode = "<script type=\"text/javascript\">\n" +
////                        "           function init()\n" +
////                        "           {\n" +
////                        "               \t   AndroidFunction.showToast(\"test\");\n" +
////                        "           }\n" +
////                        "        </script>";
////                ContentResolver contentResolver = getActivity().getContentResolver();
////              WebResourceResponse webResourceResponse = super.shouldInterceptRequest(view,request);
////
////
//                Log.d("test i r", interceptRequestString);
//                return null;
//            }

            @Override
            public void onPageFinished(WebView view, String url) {
                webView.loadUrl(
                        "javascript:\n" +
                                "\tvar touchDuration = 2000;\n" +
                                "\tvar pressTimer;\n" +
                                "\tvar element;\n" +
                                "\n" +
                                "\tdocument.addEventListener('touchstart',handleStart,false);\n" +
                                "\tdocument.addEventListener('touchend', handleEnd, false);\n" +
                                "\t\n" +
                                "\tfunction handleStart(event) {\n" +
                                "\t\tpressTimer = setTimeout(function() {handleLongTouch(event);}, touchDuration); \n" +
                                "\t}\n" +
                                "\t\n" +
                                "\tfunction handleEnd(){\n" +
                                "\t\tif (pressTimer) clearTimeout(pressTimer);\n" +
                                "\t}\n" +
                                "\t\n" +
                                "\tfunction handleLongTouch(event){\n" +
                                "\t\t if (window.getSelection) {\n" +
                                "\t\t\tvar text = window.getSelection().toString();\n"+
                                "\t\t\tWebViewInterface.getSelectText(text);\n"+
                                "\t\t}\n" +
                                "\t\telement = document.elementFromPoint(event.touches[0].clientX, event.touches[0].clientY);\n" +
                                "\t\tif(element.tagName.toLowerCase() == \"img\"){\n" +
                                "\t\t\tWebViewInterface.getClickImage(event.target.src,event.target.clientWidth,event.target.clientHeight);\n" +
                                "\t\t}\n" +
                                "\t\t\t\t\t\n" +
                                "\t\tif (pressTimer) clearTimeout(pressTimer);\n" +
                                "\t}"
                );
            }

        });
        webView.getSettings().setJavaScriptEnabled(true);
        webView.setWebChromeClient(new WebChromeClient());
        WebViewInterface webViewInterface = new WebViewInterface();
        webView.addJavascriptInterface(webViewInterface, "WebViewInterface");
        webView.loadUrl("https://zh.wikipedia.org/wiki/Wikipedia:%E9%A6%96%E9%A1%B5");
        return view;
    }

    @Override
    public void onAttach(Context context) {
        super.onAttach(context);
        if (context instanceof OnFragmentInteractionListener) {
            mListener = (OnFragmentInteractionListener) context;
        } else {
            throw new RuntimeException(context.toString()
                    + " must implement OnFragmentInteractionListener");
        }
    }

    @Override
    public void onDetach() {
        super.onDetach();
        mListener = null;
    }

    /**
     * This interface must be implemented by activities that contain this
     * fragment to allow an interaction in this fragment to be communicated
     * to the activity and potentially other fragments contained in that
     * activity.
     * <p>
     * See the Android Training lesson <a href=
     * "http://developer.android.com/training/basics/fragments/communicating.html"
     * >Communicating with Other Fragments</a> for more information.
     */
    public interface OnFragmentInteractionListener {

        void onSelectText(String selectText);

        void onClickWebImage(String imageSrc, int imageWidth, int imageHeight);

    }

    private class WebViewInterface {

        @RequiresApi(api = Build.VERSION_CODES.N)
        @JavascriptInterface
        public void getSelectText(final String selectText) {
            getActivity().runOnUiThread(new Runnable() {
                @Override
                public void run() {
                    mListener.onSelectText(selectText);
                }
            });
        }

        @RequiresApi(api = Build.VERSION_CODES.N)
        @JavascriptInterface
        public void getClickImage(final String imageSrc, final int imageWidth, final int imageHeight) {
            getActivity().runOnUiThread(new Runnable() {
                @Override
                public void run() {
                    mListener.onClickWebImage(imageSrc, imageWidth, imageHeight);
                }
            });
        }
    }

}
